/// <reference types="node" />
import * as http from 'http';
import * as https from 'https';
import { IServiceDescriptor } from '../model/serviceDescriptor';
import { ICoronerConfig } from './model/coronerConfig';
import { IDescriptorOpts } from './model/descriptorOptions';
export declare function listenDescriptor(descr: IServiceDescriptor, app: http.RequestListener, credentials: https.ServerOptions | undefined, callback: () => void | undefined, clusterSupport?: boolean | number): void;
export declare function getCoronerConfig(): ICoronerConfig;
/**
 * getDescriptor fetches the service's integration parameters.
 * @param serviceName - service name - for example: share/saml/comments
 * @param defaultPort - the default port number for the service.
 * @param opts - descriptor options
 */
export declare function getDescriptor(serviceName: string, defaultPort: number, opts?: IDescriptorOpts): IServiceDescriptor;
