/// <reference types="node" />
import { IBacktraceClientOptions } from 'backtrace-node';
import { IServiceDescriptor } from '..';
/**
 * Default service configuration
 */
export declare type IConfiguration<T> = T & {
    isProduction: boolean;
    descriptor?: IServiceDescriptor;
    metrics: IMetricsOptions & IRemoteLogger;
    logger: ILoggerOptions;
    backtrace: IBacktraceClientOptions & IRemoteLogger;
    ssl: ISslOptions | undefined;
};
/**
 * Extend Backtrace-node/Circonus metrics configuration object with
 * properties that determine metrics/reporter behavior. Developer should use
 * these variables to determine if backtrace-service should use backtrace-node/circonus integration
 */
export interface IRemoteLogger {
    enabled?: boolean;
}
export interface ISslOptions {
    key: string | Buffer;
    cert: string | Buffer;
}
export interface ILoggerOptions {
    logLevel: string;
}
export interface IMetricsOptions {
    secret: string;
    uuid: string;
    interval?: number;
    hostUrl?: string;
    disableExpressMetrics?: boolean;
}
