"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ResponseResult = /** @class */ (function () {
    function ResponseResult(msg, status) {
        if (status === void 0) { status = 'error'; }
        this.msg = msg;
        this.status = status;
    }
    ResponseResult.badRequest = function (response, msg) {
        var responseMessage = msg ? msg : 'bad request';
        response.status(400).send(new ResponseResult(responseMessage));
    };
    ResponseResult.unauthorized = function (response) {
        var responseMessage = 'unauthorized';
        response.status(403).send(new ResponseResult(responseMessage));
    };
    ResponseResult.ok = function (response) {
        response.status(403).send(new ResponseResult('ok', 'ok'));
    };
    ResponseResult.internalError = function (response, msg) {
        response.status(500).send(new ResponseResult(msg, 'error'));
    };
    return ResponseResult;
}());
exports.ResponseResult = ResponseResult;
//# sourceMappingURL=responseResult.js.map