import { NextFunction, Request, Response } from 'express';
import { IProjectsExt } from '../identity/model/serverConfiguration';
export declare function setValid(res: Express.Response): void;
export declare function setInvalid(res: Express.Response): void;
/**
 * Checks if scopedProjects are in allKnownProjects and
 *      sets projectValidated flag on response object
 */
export declare function check(res: Express.Response, allKnownProjects: IProjectsExt[], scopedProjects: (string | number)[]): boolean;
/**
 *  Middleware for Backtrace Teams
 *    Alters the Express res.send function to return 403
 *    if projectValidation flag not set.
 */
export declare function projectValidation(req: Request, res: Response, next: NextFunction): void;
