import { IConfiguration } from './../model/configuration';
/**
 * Backtrace service configuration. Class responsible for managing configuration paths/parsing them.
 */
export declare class ServiceConfiguration<T> {
    private _logger;
    /**
     * @deprecated Please use instead getProjectSettingsPath. This method is deprecated because
     * of the way how we want to read configuration files. This method will return only one
     * path to service configuration, that might be wrong for complex environment when user want to
     * override default configuration.
     *
     * Select default path for service configuraiton path in different environment
     * By default Backtrace expect to run service from root service directory
     * by using npm commands. In environment different than production
     * @ServiceConfiguration class will read configuration file from root dir.
     * Otherwise from default Backtrace configuration directory
     */
    getProjectSettingsPath(serviceName: string): string;
    /**
     * Select default paths for service configuraiton path in different environment
     * By default Backtrace expect to run service from root service directory
     * by using npm commands. In environment different than production
     * @ServiceConfiguration class will read configuration file from root dir.
     * Otherwise from default Backtrace configuration directory
     */
    getProjectSettingsPaths(serviceName: string): string[];
    /**
     * Loads service configuration file
     */
    loadConfiguration(configurationPaths: string[]): IConfiguration<T>;
}
