"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var url = __importStar(require("url"));
/**
 * Backtrae universe utils
 */
var UniverseHelper = /** @class */ (function () {
    function UniverseHelper() {
    }
    /**
     * return Backtrace host url
     * @param urlString sample url to any Backtrace resource
     * Example:
     * https://yolo.sp.backtrace.io => https://yolo.sp.backtrace.io
     * https://sampleHostName.backtrace.io/blah/poop/doop => https://sampleHostName.backtrace.io
     */
    UniverseHelper.getBacktraceHostName = function (urlString) {
        if (!urlString) {
            return undefined;
        }
        var obj = url.parse(urlString);
        return obj.protocol + "//" + obj.hostname;
    };
    /**
     * Get an universe name from Backtrace url.
     * @param urlString sample url to any Backtrace resource
     * Example:
     * https://yolo.sp.backtrace.io => yolo
     * https://sampleHostName.backtrace.io => sampleHostName
     */
    UniverseHelper.getBacktaceUniverseName = function (urlString) {
        if (!urlString) {
            return undefined;
        }
        var hostNameIndexEnd = urlString.indexOf('backtrace.io/');
        if (hostNameIndexEnd === -1) {
            return undefined;
        }
        return urlString.includes('submit.sp.backtrace.io')
            ? urlString.substring(hostNameIndexEnd, urlString.indexOf('/', hostNameIndexEnd))
            : urlString.substring(urlString.indexOf('//') + 2, urlString.indexOf('.sp.backtrace.io'));
    };
    return UniverseHelper;
}());
exports.UniverseHelper = UniverseHelper;
//# sourceMappingURL=backtraceUniverseHelper.js.map