/**
 * @license
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import * as ts from "typescript";
import * as Lint from "../index";
export declare class Rule extends Lint.Rules.AbstractRule {
    static metadata: Lint.IRuleMetadata;
    static LOWERCASE_FAILURE: string;
    static SPACE_LOWERCASE_FAILURE: string;
    static UPPERCASE_FAILURE: string;
    static SPACE_UPPERCASE_FAILURE: string;
    static LEADING_SPACE_FAILURE: string;
    static IGNORE_WORDS_FAILURE_FACTORY: (words: string[]) => string;
    static IGNORE_PATTERN_FAILURE_FACTORY: (pattern: string) => string;
    apply(sourceFile: ts.SourceFile): Lint.RuleFailure[];
}
